require 'captio/captor'
require 'captio/version'

class Captio

  def initialize
    @captors = []
  end

  def add(*streams, &block)
    streams.each do |stream|
      Captor.new(stream).tap do |captor|
        @captors << captor
        block.call(captor)
      end
    end
  end

  def capture
    raise ArgumentError, "Block required" unless block_given?

    @captors.map(&:start!)

    begin
      yield
    ensure
      @captors.map(&:restore!)
    end
  end
end
