require 'captio/emitter'
require 'captio/stateful'
require 'captio/scheduler'

class Captio
  class Captor
    prepend Emitter
    prepend Stateful

    states :new, :started, :restored
    events :start, :capture_line, :capture_block, :restore, :error

    verb :start, state: :new do
      @fiber.resume
    end

    verb :restore, state: :started do
      @fiber.resume
      @fiber = nil
    end

    def initialize(stream)
      @listeners = {}
      @fiber = Scheduler.schedule_capture_fiber(stream, self)
    end
  end
end
