class Captio
  module Emitter
    def self.included(base)
      prepended(base)
    end

    def self.prepended(base)
      base.extend ClassMethods
    end

    def on(event, &block)
      if self.class.events.include?(event)
        @listeners ||= {}
        @listeners[event] ||= []
        @listeners[event] << block
        true
      else
        false
      end
    end

    def emit(event, *args)
      @listeners[event].each{ |l| l.call(*args) } if @listeners[event]
    end

    module ClassMethods
      def events(*events)
        define_singleton_method('events') do
          events
        end
      end
    end
  end
end

